import { InjectionToken, Injector, OnInit } from '@angular/core';
import { NgControl, ValidatorFn } from '@angular/forms';
import { DateAdapter } from '@ng-tangram/components/core';
import { DateFilterFn } from './datepicker-control';
import { NtDatePickerInputBase } from './datepicker-input-base';
import { DateRange } from './selections';
export interface NtDateRangePickerParent<D> {
    _startDate: NtDateRangePart<D>;
    _endDate: NtDateRangePart<D>;
    min: D | null;
    max: D | null;
    dateFilter: DateFilterFn<D> | undefined;
}
export declare const NT_DATE_RANGE_PICKER_PARENT: InjectionToken<NtDateRangePickerParent<unknown>>;
export declare abstract class NtDateRangePart<D> extends NtDatePickerInputBase<DateRange<D>, D> implements OnInit {
    protected _rangePicker: NtDateRangePickerParent<D>;
    private _injector;
    ngControl: NgControl | null;
    constructor(dateAdapter: DateAdapter<D>, _rangePicker: NtDateRangePickerParent<D>, _injector: Injector);
    ngOnInit(): void;
    _getMinDate(): D | null;
    _getMaxDate(): D | null;
    protected _getDateFilter(): DateFilterFn<D> | undefined;
}
export declare class NtDateRangeStart<D> extends NtDateRangePart<D> {
    private _startValidator;
    protected _assignValueToModel(value: D): void;
    protected _getValueFromModel(modelValue: DateRange<D>): D | null;
    protected _validator: ValidatorFn | null;
}
export declare class NtDateRangeEnd<D> extends NtDateRangePart<D> {
    private _endValidator;
    protected _assignValueToModel(value: D): void;
    protected _getValueFromModel(modelValue: DateRange<D>): D | null;
    protected _validator: ValidatorFn | null;
}
