import { AfterContentInit, ChangeDetectorRef, ElementRef, OnChanges } from '@angular/core';
import { ControlContainer, NgControl } from '@angular/forms';
import { DateAdapter, NtDateFormats } from '@ng-tangram/components/core';
import { NtFormFieldControl } from '@ng-tangram/components/forms';
import { NtDateRangeEnd, NtDateRangePickerParent, NtDateRangeStart } from './date-range-parts.directive';
import { NtDatePickerBase } from './datepicker-base';
import { NtDatePickerIcons } from './datepicker-icons';
import { DateRange, NtDateSelectionModel } from './selections';
export declare class NtDateRangePicker<D> extends NtDatePickerBase<DateRange<D>, D> implements NtDateRangePickerParent<D>, NtFormFieldControl<DateRange<D>>, AfterContentInit, OnChanges {
    id: string;
    ngControl: NgControl | null;
    _displayValue: string;
    private _placeholder;
    get placeholder(): string;
    set placeholder(value: string);
    private _disabled;
    get disabled(): boolean;
    set disabled(value: boolean);
    private _required;
    get required(): boolean;
    set required(value: boolean);
    private _readonly;
    get readonly(): boolean;
    set readonly(value: boolean);
    _startDate: NtDateRangeStart<D>;
    _endDate: NtDateRangeEnd<D>;
    constructor(elementRef: ElementRef, tabIndex: string, icons: NtDatePickerIcons, dateFormats: NtDateFormats, changeDetectorRef: ChangeDetectorRef, dateAdapter: DateAdapter<D>, model: NtDateSelectionModel<DateRange<D>, D>, control: ControlContainer);
    ngAfterContentInit(): void;
    _isActivated(): boolean;
    _getStartValue(): D | null;
    getErrors(): {};
    protected _getValueFromModel(modelValue: DateRange<D>): D | null;
    protected _formatValue(modelValue: DateRange<D>): void;
    protected _getDefaultModelValue(): DateRange<D>;
    private _formatPartValue;
}
