import { AfterViewInit, ChangeDetectorRef, ElementRef, OnDestroy } from '@angular/core';
import { DateAdapter } from '@ng-tangram/components/core';
import { NtCalendarUserEvent } from './calendar-body.component';
import { NtDatePickerCalendar } from './calendar.component';
import { NtDatePickerControl } from './datepicker-control';
import { DateRange, ExtractDateTypeFromSelection, NtDateRangeSelectionStrategy, NtDateSelectionModel } from './selections';
export declare class NtDatePickerContent<S, D = ExtractDateTypeFromSelection<S>> implements AfterViewInit, OnDestroy {
    elementRef: ElementRef;
    private _changeDetectorRef;
    private _model;
    private _dateAdapter;
    private _rangeSelectionStrategy;
    datepicker: NtDatePickerControl<D>;
    private _subscriptions;
    _calendar: NtDatePickerCalendar<D>;
    comparisonStart: D | null;
    comparisonEnd: D | null;
    constructor(elementRef: ElementRef, _changeDetectorRef: ChangeDetectorRef, _model: NtDateSelectionModel<S, D>, _dateAdapter: DateAdapter<D>, _rangeSelectionStrategy: NtDateRangeSelectionStrategy<D>, datepicker: NtDatePickerControl<D>);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    _handleUserSelection(event: NtCalendarUserEvent<D | null>): void;
    _getSelected(): D | DateRange<D> | null;
}
