import { Observable } from 'rxjs';
import { InjectionToken } from '@angular/core';
import { NtOverlayComponent } from '@ng-tangram/components/overlay';
import { NtCalendarCellClassFunction } from './calendar-body.component';
export declare type DateFilterFn<D> = (date: D | null) => boolean;
export interface NtDatePickerControl<D> {
    id?: string;
    startAt: D | null;
    min: D | null;
    max: D | null;
    dateClass: NtCalendarCellClassFunction<D>;
    dateFilter: DateFilterFn<D>;
    overlay: NtOverlayComponent;
    _stateChanges: Observable<void>;
}
export declare const NT_DATE_PICKER_CONTROL: InjectionToken<NtDatePickerControl<unknown>>;
