import { Subject } from 'rxjs';
import { OnDestroy, OnInit } from '@angular/core';
import { AbstractControl, ControlValueAccessor, NgControl, ValidationErrors, Validator, ValidatorFn } from '@angular/forms';
import { DateAdapter } from '@ng-tangram/components/core';
import { DateFilterFn } from './datepicker-control';
import { ExtractDateTypeFromSelection, NtDateSelectionModel } from './selections';
export declare abstract class NtDatePickerInputBase<S, D = ExtractDateTypeFromSelection<S>> implements OnInit, OnDestroy, ControlValueAccessor, Validator {
    protected _dateAdapter: DateAdapter<D>;
    ngControl: NgControl | null;
    private _value;
    get value(): D | null;
    set value(value: D | null);
    private _disabled;
    get disabled(): boolean;
    set disabled(value: boolean);
    private _required;
    get required(): boolean;
    set required(value: boolean);
    protected _lastValueValid: boolean;
    protected _model: NtDateSelectionModel<S, D>;
    protected abstract _validator: ValidatorFn | null;
    protected abstract _assignValueToModel(value: D | null): void;
    protected abstract _getValueFromModel(modelValue: S): D | null;
    abstract _getMinDate(): D | null;
    abstract _getMaxDate(): D | null;
    protected abstract _getDateFilter(): DateFilterFn<D> | undefined;
    private _onChange;
    _onTouched: () => void;
    _validatorOnChange: () => void;
    readonly stateChanges: Subject<void>;
    private _valueChangesSubscription;
    private _localeSubscription;
    constructor(_dateAdapter: DateAdapter<D>);
    ngOnInit(): void;
    ngOnDestroy(): void;
    writeValue(value: D): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
    registerOnValidatorChange(fn: () => void): void;
    validate(c: AbstractControl): ValidationErrors | null;
    _valueChange(value: D | null): void;
    _registerModel(model: NtDateSelectionModel<S, D>): void;
    private _assignValue;
    private _isValidValue;
    private _parseValidator;
    private _filterValidator;
    private _minValidator;
    private _maxValidator;
    protected _getValidators(): ValidatorFn[];
}
