import { AfterContentInit, ChangeDetectorRef, EventEmitter, OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
import { DateAdapter, NtDateFormats } from '@ng-tangram/components/core';
import { NtCalendarBody, NtCalendarCell, NtCalendarCellClassFunction, NtCalendarUserEvent } from './calendar-body.component';
import { DateRange, NtDateRangeSelectionStrategy } from './selections';
export declare class NtCalendarMonth<D> implements AfterContentInit, OnChanges, OnDestroy {
    private _changeDetectorRef;
    _dateAdapter: DateAdapter<D>;
    private _dateFormats;
    private _rangeStrategy?;
    private _rerenderSubscription;
    private _activeDate;
    get activeDate(): D;
    set activeDate(value: D);
    private _selected;
    get selected(): DateRange<D> | D | null;
    set selected(value: DateRange<D> | D | null);
    private _minDate;
    get minDate(): D | null;
    set minDate(value: D | null);
    private _maxDate;
    get maxDate(): D | null;
    set maxDate(value: D | null);
    dateFilter: (date: D) => boolean;
    dateClass: NtCalendarCellClassFunction<D>;
    comparisonStart: D | null;
    comparisonEnd: D | null;
    readonly selectedChange: EventEmitter<D | null>;
    readonly _userSelection: EventEmitter<NtCalendarUserEvent<D | null>>;
    readonly activeDateChange: EventEmitter<D>;
    _calendarBody: NtCalendarBody;
    _monthLabel: string;
    _weeks: NtCalendarCell[][];
    _firstWeekOffset: number;
    _rangeStart: number | null;
    _rangeEnd: number | null;
    _comparisonRangeStart: number | null;
    _comparisonRangeEnd: number | null;
    _previewStart: number | null;
    _previewEnd: number | null;
    _isRange: boolean;
    _todayDate: number | null;
    _weekdays: {
        long: string;
        narrow: string;
    }[];
    constructor(_changeDetectorRef: ChangeDetectorRef, _dateAdapter: DateAdapter<D>, _dateFormats: NtDateFormats, _rangeStrategy?: NtDateRangeSelectionStrategy<D> | undefined);
    ngAfterContentInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    _dateSelected(event: NtCalendarUserEvent<number>): void;
    _init(): void;
    _focusActiveCell(movePreview?: boolean): void;
    _previewChanged({ event, value: cell }: NtCalendarUserEvent<NtCalendarCell<D> | null>): void;
    private _initWeekdays;
    private _createWeekCells;
    private _fillBeforeCells;
    private _fillAfterCells;
    private _shouldEnableDate;
    private _getDateInCurrentMonth;
    private _hasSameMonthAndYear;
    private _getCellCompareValue;
    private _setRanges;
}
