import { FactoryProvider, InjectionToken } from '@angular/core';
import { DateAdapter } from '@ng-tangram/components/core';
import { DateRange } from './date-selection-model';
export declare const NT_DATE_RANGE_SELECTION_STRATEGY: InjectionToken<NtDateRangeSelectionStrategy<any>>;
export interface NtDateRangeSelectionStrategy<D> {
    selectionFinished(date: D | null, currentRange: DateRange<D>, event: Event): DateRange<D>;
    createPreview(activeDate: D | null, currentRange: DateRange<D>, event: Event): DateRange<D>;
}
export declare class DefaultNtCalendarRangeStrategy<D> implements NtDateRangeSelectionStrategy<D> {
    private _dateAdapter;
    constructor(_dateAdapter: DateAdapter<D>);
    selectionFinished(date: D, currentRange: DateRange<D>): DateRange<D>;
    createPreview(activeDate: D | null, currentRange: DateRange<D>): DateRange<D>;
}
export declare function NT_CALENDAR_RANGE_STRATEGY_PROVIDER_FACTORY(parent: NtDateRangeSelectionStrategy<unknown>, adapter: DateAdapter<unknown>): NtDateRangeSelectionStrategy<unknown>;
export declare const NT_CALENDAR_RANGE_STRATEGY_PROVIDER: FactoryProvider;
