import { AfterContentInit, ChangeDetectorRef, EventEmitter, OnDestroy } from '@angular/core';
import { DateAdapter, NtDateFormats } from '@ng-tangram/components/core';
import { NtCalendarBody, NtCalendarCell, NtCalendarCellClassFunction, NtCalendarUserEvent } from './calendar-body.component';
export declare class NtCalendarYear<D> implements AfterContentInit, OnDestroy {
    private _changeDetectorRef;
    _dateAdapter: DateAdapter<D>;
    private _dateFormats;
    private _rerenderSubscription;
    private _activeDate;
    get activeDate(): D;
    set activeDate(value: D);
    private _selected;
    get selected(): D | null;
    set selected(value: D | null);
    private _minDate;
    get minDate(): D | null;
    set minDate(value: D | null);
    private _maxDate;
    get maxDate(): D | null;
    set maxDate(value: D | null);
    dateFilter: (date: D) => boolean;
    dateClass: NtCalendarCellClassFunction<D>;
    readonly selectedChange: EventEmitter<D>;
    readonly monthSelected: EventEmitter<D>;
    readonly activeDateChange: EventEmitter<D>;
    _calendarBody: NtCalendarBody;
    _months: NtCalendarCell[][];
    _yearLabel: string;
    _todayMonth: number | null;
    _selectedMonth: number | null;
    constructor(_changeDetectorRef: ChangeDetectorRef, _dateAdapter: DateAdapter<D>, _dateFormats: NtDateFormats);
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    _init(): void;
    _monthSelected(event: NtCalendarUserEvent<number>): void;
    _focusActiveCell(): void;
    private _getMonthInCurrentYear;
    private _createCellForMonth;
    private _shouldEnableMonth;
    private _isYearAndMonthAfterMaxDate;
    private _isYearAndMonthBeforeMinDate;
    private _setSelectedMonth;
}
