export interface NtNotifierOptions {
    animations?: {
        enabled?: boolean;
        hide?: {
            easing?: string;
            offset?: number | false;
            preset?: string;
            speed?: number;
        };
        overlap?: number | false;
        shift?: {
            easing?: string;
            speed?: number;
        };
        show?: {
            easing?: string;
            preset?: string;
            speed?: number;
        };
    };
    behaviour?: {
        hiddenStrategy?: 'never' | 'content' | 'absoluted';
        hiddenTime?: number;
        onClick?: 'hide' | false;
        onMouseover?: 'pauseAutoHide' | 'resetAutoHide' | false;
        showDismissButton?: boolean;
        stacking?: number | false;
    };
    position?: {
        horizontal?: {
            distance?: number;
            position?: 'left' | 'middle' | 'right';
        };
        vertical?: {
            distance?: number;
            gap?: number;
            position?: 'top' | 'bottom';
        };
    };
    theme?: string;
}
export declare class NtNotifierConfig implements NtNotifierOptions {
    animations: {
        enabled: boolean;
        hide: {
            easing: string;
            offset: number | false;
            preset: string;
            speed: number;
        };
        overlap: number | false;
        shift: {
            easing: string;
            speed: number;
        };
        show: {
            easing: string;
            preset: string;
            speed: number;
        };
    };
    behaviour: {
        hiddenStrategy: 'never' | 'content' | 'absoluted';
        hiddenTime?: number;
        onClick: 'hide' | false;
        onMouseover: 'pauseAutoHide' | 'resetAutoHide' | false;
        showDismissButton: boolean;
        stacking: number | false;
    };
    position: {
        horizontal: {
            distance: number;
            position: 'left' | 'middle' | 'right';
        };
        vertical: {
            distance: number;
            gap: number;
            position: 'top' | 'bottom';
        };
    };
    constructor(customOptions?: NtNotifierOptions);
}
