import { AfterViewInit, ElementRef, EventEmitter, Renderer2 } from '@angular/core';
import { NtNotifierAnimation } from './notifier-animation';
import { NtNotifierConfig } from './notifier-config';
import { NtNotifierIcons } from './notifier-icons';
import { NtNotifierRef } from './notifier-ref';
import { NtNotifierTimer } from './notifier-timer';
import { NtNotifier } from './notifier.service';
export declare class NtNotifierComponent implements AfterViewInit {
    private renderer;
    private _notifierTimer;
    private _notifierAnimation;
    icons: NtNotifierIcons;
    notification: NtNotifierRef;
    ready: EventEmitter<NtNotifierComponent>;
    dismiss: EventEmitter<string>;
    readonly config: NtNotifierConfig;
    private readonly _element;
    private _elementHeight;
    private _elementWidth;
    private _elementShift;
    get _hasIcon(): boolean;
    constructor(elementRef: ElementRef, notifier: NtNotifier, renderer: Renderer2, _notifierTimer: NtNotifierTimer, _notifierAnimation: NtNotifierAnimation, icons: NtNotifierIcons);
    ngAfterViewInit(): void;
    getConfig(): NtNotifierConfig;
    getHeight(): number;
    getWidth(): number;
    getShift(): number;
    show(): Promise<undefined>;
    hide(): Promise<undefined>;
    shift(distance: number, shiftToMakePlace: boolean): Promise<undefined>;
    onClickDismiss(): void;
    onNotificationMouseover(): void;
    onNotificationMouseout(): void;
    onNotificationClick(): void;
    private _startHideTimer;
    private _pauseHideTimer;
    private _continueHideTimer;
    private _stopHideTimer;
    private _getAutoHideable;
    private _getHiddenTime;
    private _setup;
}
